/*****************************************************************************
  Pocket BASIC

  |PRBASICC^[v^

  Choi Kyun

  2009-10

  ver 0.1.0
*****************************************************************************/


#include <PalmOS.h>
#include <PalmOSGlue.h>
#include <ctype.h>


//#define GLOBAL_VALUE_DEFINE

/* MathLib headers */
#include "MathLib.h"

#include "tiny_basic.h"
#include "tiny_basic_Rsc.h"
#include "basic.h"



// vOGAf[^x[X

Err
open_program_area_db( void )
{
  Err err = errNone;
  UInt16 mode = dmModeReadWrite;
  LocalID db_id;
  UInt16 card_no, version, index;
  UInt16 attr;
  MemHandle h;
  MemPtr p;


  // I[v
  g_pa_db_p = DmOpenDatabaseByTypeCreator('DATA', appFileCreator, mode );

  // o[W`FbN
  if( g_pa_db_p )
    {
      DmOpenDatabaseInfo( g_pa_db_p, &db_id, NULL, NULL, &card_no, NULL );
      DmDatabaseInfo( card_no, db_id, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
      if( version != PROGRAM_AREA_VER )
        {
          DmCloseDatabase( g_pa_db_p );
          DmDeleteDatabase( 0, db_id );
          g_pa_db_p = NULL;
        }
    }

  // VK쐬
  if( g_pa_db_p == NULL )
    {
      err = DmCreateDatabase( 0, "PocketBasicDB", appFileCreator, 'DATA', false );
      if( err )
        {
          return err;
        }
      g_pa_db_p = DmOpenDatabaseByTypeCreator( 'DATA', appFileCreator, mode );
      if( g_pa_db_p == NULL )
        {
          return err;
        }
      // obNAbvݒ
      DmOpenDatabaseInfo( g_pa_db_p, &db_id, NULL, NULL, &card_no, NULL );
      DmDatabaseInfo( card_no, db_id, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );
      attr |= dmHdrAttrBackup;
      DmSetDatabaseInfo( card_no, db_id, NULL, &attr, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );

      // o[Wݒ
      version = PROGRAM_AREA_VER;
      DmOpenDatabaseInfo( g_pa_db_p, &db_id, NULL, NULL, &card_no, NULL );
      DmSetDatabaseInfo( card_no, db_id, NULL, NULL, &version, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL );

      // R[h쐬
      index = 0;
      h = DmNewRecord( g_pa_db_p, &index, sizeof(char) * MAX_PROGRAM_AREA_NUM * MAX_PROGRAM_SIZE );
      err = DmGetLastErr();
      if ( err )
        {
          DmCloseDatabase( g_pa_db_p );
          return err;
        }
      // 
      p = MemHandleLock( h );
      DmSet( p, 0, sizeof(char) * MAX_PROGRAM_AREA_NUM * MAX_PROGRAM_SIZE, 0 );

      MemHandleUnlock( h );
      DmReleaseRecord( g_pa_db_p, index, true );
    }

  // R[h̃|C^擾
  h = DmGetRecord( g_pa_db_p, 0 );
  err = DmGetLastErr();
  if ( err )
    {
      DmCloseDatabase( g_pa_db_p );
      return err;
    }

  g_pa_record_h = h;
  p = MemHandleLock( h );
  g_pa_record_p = ( void *) p;

  // vOGÃ[h
  MemMove( g_pa_p, p, sizeof(char) * MAX_PROGRAM_AREA_NUM * MAX_PROGRAM_SIZE );

  return err;
}



// f[^x[XN[Y
void
close_program_area_db( void )
{
  // vOGÃZ[u
  DmWrite( g_pa_record_p, 0, g_pa_p, sizeof(char) * MAX_PROGRAM_AREA_NUM * MAX_PROGRAM_SIZE );

  MemHandleUnlock( g_pa_record_h );
  DmReleaseRecord( g_pa_db_p, 0, true );

  DmCloseDatabase( g_pa_db_p );
}



// f[^x[X폜
void
delete_program_area_db( void )
{
  DmDeleteDatabase( 0, DmFindDatabase( 0, "PocketBasicDB" ) );
}




